#include "abuleduquestionqcm.h"
#include "ui_abuleduquestionqcm.h"
#include <QDebug>

AbulEduQuestionQCM::AbulEduQuestionQCM(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::AbulEduQuestionQCM),
    m_serialNumber(0)
{
    ui->setupUi(this);
    m_answers.clear();
    m_answers.append(QPair<QTextEdit*,AbulEduFlatBoutonV1*>(ui->teR1,ui->btnImageR1));
    m_answers.append(QPair<QTextEdit*,AbulEduFlatBoutonV1*>(ui->teR2,ui->btnImageR2));
    connect(ui->btnImageQuestion, SIGNAL(clicked()),this, SLOT(onFlatBtnReponseClicked()));
    connect(ui->btnImageR1, SIGNAL(clicked()),this, SLOT(onFlatBtnReponseClicked()));
    connect(ui->btnImageR2, SIGNAL(clicked()),this, SLOT(onFlatBtnReponseClicked()));
}

AbulEduQuestionQCM::~AbulEduQuestionQCM()
{
    delete ui;
}

void AbulEduQuestionQCM::setQuestion(QString question, QString imageQuestion)
{
    ui->teQuestion->setText(question);
    if (!imageQuestion.isNull())
    {
        ui->btnImageQuestion->setIconeNormale(imageQuestion);
    }
}

void AbulEduQuestionQCM::on_btnAjouterReponse_clicked(QString reponse, QString image)
{
    QWidget* wid = new QWidget();
    QGridLayout* GBoxWid = new QGridLayout(wid);
    QLabel* label = new QLabel("Texte solution : ");
    GBoxWid->addWidget(label,0,0);
    QTextEdit* textEdit = new QTextEdit(reponse);
    GBoxWid->addWidget(textEdit,1,0);
    AbulEduFlatBoutonV1* flat = new AbulEduFlatBoutonV1();
    connect(flat,SIGNAL(clicked()),this,SLOT(onFlatBtnReponseClicked()));
    if (image.isNull())
    {
        flat->setText(trUtf8("Image Solution"));
    }
    else
    {
        flat->setIconeNormale(image);
    }
    GBoxWid->addWidget(flat,1,1);
    m_answers.append(QPair<QTextEdit*,AbulEduFlatBoutonV1*>(textEdit,flat));
    ui->twReponses->addTab(wid,trUtf8("Réponse ")+QString::number(m_answers.size()));
    ui->twReponses->setCurrentWidget(wid);
    ui->twReponses->setTabIcon(ui->twReponses->currentIndex(),QIcon(":/abuleduqcm/editeur/faux"));
}

void AbulEduQuestionQCM::onFlatBtnReponseClicked()
{
    AbulEduFlatBoutonV1* bouton = (AbulEduFlatBoutonV1*) sender();
    AbulEduMessageBoxV1* msgEnregistrement = new AbulEduMessageBoxV1(trUtf8("Deux minutes !!"), trUtf8("Bientôt, on pourra mettre une image ici"));
    msgEnregistrement->setWink();
    msgEnregistrement->show();
}

void AbulEduQuestionQCM::setAnswer(QString answer, QString image)
{
    on_btnAjouterReponse_clicked(answer,image);
}

QList<QPair<QString, QString> > AbulEduQuestionQCM::abeQuestionGetAnswersStrings()
{
    QList<QPair<QString, QString> > retour;
    for(int i = 0;i < m_answers.size();i++)
    {
        // le second du QPair est le chemin de l'icone de l'AbulEduFlatBoutonV1... à récupérer plus tard
        retour.append(QPair<QString, QString>(m_answers[i].first->toPlainText(),"nom à récupérer pour image "+QString::number(i)));
    }
    return retour;
}

QString AbulEduQuestionQCM::abeQuestionGetQuestion()
{
    return ui->teQuestion->toPlainText();
}
