#ifndef ABULEDUQUESTIONQCM_H
#define ABULEDUQUESTIONQCM_H

#include <QWidget>
#include <QTextEdit>
#include "abuleduflatboutonv1.h"
#include "abuledumessageboxv1.h"

namespace Ui {
class AbulEduQuestionQCM;
}

class AbulEduQuestionQCM : public QWidget
{
    Q_OBJECT
    
public:
    explicit AbulEduQuestionQCM(QWidget *parent = 0);
    ~AbulEduQuestionQCM();

    /** Met à jour la variable m_serialNumber, qui représente le numéro d'ordre de la question */
    inline void setSerialNumber(int number) {m_serialNumber = number;}

    /** Écris le texte de la question.
      * @param Il peut ne pas y avoir d'image à la question, donc le second paramètre est initialisé à une chaine nulle */
    void setQuestion(QString question,QString imageQuestion = QString());

    /** Écris les deux premières solutions à proposer
      * @note Il ne peut y avoir moins de deux solutions proposées
      * @param firstImage est le chemin de l'image de la première réponse proposée, initialisé à une chaine nulle
      * @param secondImage est le chemin de l'image de la deuxième réponse proposée, initialisé à une chaine nulle
      * @attention si on veut une image à la seconde réponse et pas à la première, il faudrait mettre QString("") comme troisième paramètre */
    void setMinAnswers(QString firstAnswer, QString secondAnswer,QString firstImage = QString(),QString secondImage = QString());
    
    /** Écris une réponse */
    void setAnswer(QString answer,QString image = QString());

    /** Retourne les réponses à la question */
    QList<QPair<QString,QString> > abeQuestionGetAnswersStrings();

    /** Retourne la question */
    QString abeQuestionGetQuestion();

private slots:
    void on_btnAjouterReponse_clicked(QString reponse = QString(),QString image = QString());
    void onFlatBtnReponseClicked();

private:
    Ui::AbulEduQuestionQCM *ui;

    /** Le numéro d'ordre de la question */
    int m_serialNumber;

    /** Les réponses à la question */
    QList<QPair<QTextEdit*,AbulEduFlatBoutonV1*> > m_answers;

};

#endif // ABULEDUQUESTIONQCM_H
