/**
  * AbulEduGraphicMenuV1
  * @see https://redmine.ryxeo.com/projects/ryxeo/wiki/AbulEduGraphicMenuV1
  * @see https://redmine.ryxeo.com/projects/ryxeo/wiki/Le_menu_graphique
  *
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @author 2012 Éric Seigne <eric.seigne@ryxeo.com>
  * @see The GNU Public License (GPL)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program; if not, write to the Free Software Foundation, Inc.,
  * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  */

#include "abuledugraphicmenuv1.h"
#include "ui_abuledugraphicmenuv1.h"
#include <QToolTip>

AbulEduGraphicMenuV1::AbulEduGraphicMenuV1(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::AbulEduGraphicMenuV1)
{
    m_localDebug = false;
    if(m_localDebug)
        qDebug() << "AbulEduGraphicMenuV1::AbulEduGraphicMenuV1 (1)";
    ui->setupUi(this);

    raise();

    //================================================================================
    //Lecture du fichier conf pour faire une liste qu'on utilisera pour les changements
    //de taille des widget *ET* pour les animations (ouverture/fermeture)
    QSettings config(":/abuledugraphicmenuv1/abuledugraphicmenuv1.conf",QSettings::IniFormat);
    int size = config.beginReadArray("graphicsmenu");
    //    qDebug() << "AbulEduGraphicMenuV1::setPieces : contenu du fichier ini " << size;
    for(int i = 0; i < size ; i++) {
        config.setArrayIndex(i);
        QString composant(config.value("name").toString());
        m_listeComposants << composant;
    }

    m_imageFond.load(":/abuledugraphicmenuv1/fond-01");
    resize(m_imageFond.size());
    m_sizeWidget = this->geometry().size();

    ui->btnAide->setIconeNormale(QString(":/abuledugraphicmenuv1/btnAide"));
    ui->btnAide->setIconePressed(QString(":/abuledugraphicmenuv1/btnAide-over"));
    ui->btnAide->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnAide-over"));
    ui->btnAide->setTexteAlignement(Qt::AlignBottom);
    ui->btnAide->setToolTip(trUtf8("Aide"));
    ui->btnAide->setCursor(Qt::PointingHandCursor);
    ui->btnAide->hide();

    ui->btnFermer->setIconeNormale(QString(":/abuledugraphicmenuv1/btnFermer"));
    ui->btnFermer->setIconePressed(QString(":/abuledugraphicmenuv1/btnFermer-over"));
    ui->btnFermer->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnFermer-over"));
    ui->btnFermer->setToolTip(trUtf8("Replier le menu"));
    ui->btnFermer->setTexteAlignement(Qt::AlignBottom);
    ui->btnFermer->setCursor(Qt::PointingHandCursor);
    ui->btnFermer->hide();

    ui->btnBox->setIconeNormale(QString(":/abuledugraphicmenuv1/btnBox"));
    ui->btnBox->setIconePressed(QString(":/abuledugraphicmenuv1/btnBox-over"));
    ui->btnBox->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnBox-over"));
    ui->btnBox->setToolTip(trUtf8("Ouvrir un module"));
    ui->btnBox->setTexteAlignement(Qt::AlignBottom);
    ui->btnBox->setCursor(Qt::PointingHandCursor);
    ui->btnBox->hide();

    ui->btnLivret->setIconeNormale(QString(":/abuledugraphicmenuv1/btnLivret"));
    ui->btnLivret->setIconePressed(QString(":/abuledugraphicmenuv1/btnLivret-over"));
    ui->btnLivret->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnLivret-over"));
    ui->btnLivret->setToolTip(trUtf8("Le livret de compétences"));
    ui->btnLivret->setTexteAlignement(Qt::AlignBottom);
    ui->btnLivret->setCursor(Qt::PointingHandCursor);
    ui->btnLivret->hide();

    ui->btnQuitter->setIconeNormale(QString(":/abuledugraphicmenuv1/btnQuitter"));
    ui->btnQuitter->setIconePressed(QString(":/abuledugraphicmenuv1/btnQuitter-over"));
    ui->btnQuitter->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnQuitter-over"));
    ui->btnQuitter->setToolTip(trUtf8("Quitter l'application"));
    ui->btnQuitter->setTexteAlignement(Qt::AlignBottom);
    ui->btnQuitter->setCursor(Qt::PointingHandCursor);
    ui->btnQuitter->hide();

    ui->btnOuvrirMenu->setIconeNormale(QString(":/abuledugraphicmenuv1/btnOuvrirMenu"));
    ui->btnOuvrirMenu->setIconePressed(QString(":/abuledugraphicmenuv1/btnOuvrirMenu-over"));
    ui->btnOuvrirMenu->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnOuvrirMenu-over"));
    ui->btnOuvrirMenu->setToolTip(trUtf8("Déplier le menu"));
    ui->btnOuvrirMenu->setTexteAlignement(Qt::AlignBottom);
    ui->btnOuvrirMenu->setCursor(Qt::PointingHandCursor);
    //    ui->btnOuvrirMenu->hide();

    ui->btnParametres->setIconeNormale(QString(":/abuledugraphicmenuv1/btnParametres"));
    ui->btnParametres->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnParametres-over"));
    ui->btnParametres->setToolTip(trUtf8("Modifier les paramètres"));
    ui->btnParametres->setTexteAlignement(Qt::AlignBottom);
    ui->btnParametres->setCursor(Qt::PointingHandCursor);
    ui->btnParametres->hide();

    //    ui->btnOuvrir->setIconeNormale(QString(":/abuledugraphicmenuv1/btnOuvrir"));
    //    ui->btnOuvrir->setIconeSurvol(QString(":/abuledugraphicmenuv1/btnOuvrir-over"));
    //    ui->btnOuvrir->setToolTip(trUtf8("Ouvrir un fichier"));
    //    ui->btnOuvrir->setTexteAlignement(Qt::AlignBottom);
    //    ui->btnOuvrir->setCursor(Qt::PointingHandCursor);
    //    ui->btnOuvrir->hide();

    m_animationStep = 0;

    setDimensionsWidget();
    deplierMenu();

    if(parent->inherits("AbulEduPageAccueilV1")) {
        connect(parent, SIGNAL(dimensionsChangees()),this, SLOT(setDimensionsWidget()), Qt::UniqueConnection);
    }
    if(m_localDebug)
        qDebug() << "AbulEduGraphicMenuV1::AbulEduGraphicMenuV1 (2)";

#ifdef __ABULEDUTABLETTEV1__MODE__
    /// 13/12/2012 Icham -> mode tablette, pas de tooltips (pas de survol en mode tactile, et puis ça faisait des trucs bizarres parfois)
    /// 02/01/2013 iCHAM -> icones survol = icones normales
    // on cherche tous les enfants, et on leur met une chaine vide en tooltips (= desactivation)
    foreach (QWidget *obj, findChildren<QWidget*>()) {
        obj->setToolTip("");
        if(dynamic_cast<AbulEduFlatBoutonV1*>(obj)){
            dynamic_cast<AbulEduFlatBoutonV1*>(obj)->setIconeSurvol(dynamic_cast<AbulEduFlatBoutonV1*>(obj)->getIconeNormale());
        }
    }
#endif
}

AbulEduGraphicMenuV1::~AbulEduGraphicMenuV1()
{
    delete ui;
}

void AbulEduGraphicMenuV1::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void AbulEduGraphicMenuV1::setDimensionsWidget()
{
    if(m_localDebug)
        qDebug()<<"                   AbulEduGraphicMenuV1::setDimensionsWidget()";
    move(this->parentWidget()->width() - this->width(), 0);
    float ratio = abeApp->getAbeApplicationDecorRatio();
    QPixmap imagefondScaled = m_imageFond.scaled(m_imageFond.size()*ratio, Qt::KeepAspectRatio, Qt::SmoothTransformation);
    //    m_imageFond = m_imageFond.scaled(m_imageFond.size()*ratio, Qt::KeepAspectRatio, Qt::SmoothTransformation);
    setFixedSize(imagefondScaled.size());
    ui->lblImageFond->setPixmap(imagefondScaled);
    ui->lblImageFond->setFixedSize(imagefondScaled.size());
    setFixedSize(m_sizeWidget * ratio);

    ui->lblLeft->move(0,0);
    ui->lblLeft->resize(QPixmap(":/abuledugraphicmenuv1/lblLeft").size()*ratio);
    ui->lblLeft->setPixmap(QPixmap(":/abuledugraphicmenuv1/lblLeft").scaled(ui->lblLeft->size()));

    //Debut du calcul du positionnement horizontal
    int x = ui->lblImageFond->pos().x();

    //================================================================================
    //Utilisation de la liste (evite de faire un acces au fichier de conf a chaque fois)
    for(int i = 0; i < m_listeComposants.size() ; i++) {
        QString composant(m_listeComposants.at(i));
        //Si c'est un bouton
        //        qDebug() << "AbulEduGraphicMenuV1 : " << composant;
        if(QPointer<AbulEduFlatBoutonV1> btn = findChild<AbulEduFlatBoutonV1 *>(composant)) {
            btn->resize(QPixmap(QString(":/abuledugraphicmenuv1/%1").arg(composant)).size()*ratio);
            btn->move(x,0);
            x += btn->width();
            //            qDebug() << "btn x : " << x;
        }
        else if (QPointer<QLabel> l = findChild<QLabel *>(composant)) {
            l->move(x,0);
            l->resize(QPixmap(QString(":/abuledugraphicmenuv1/%1").arg(composant)).size()*ratio);
            x += l->width();
            //            qDebug() << "label  x : " << x;
        }
    }

    //cas particulier du bouton OuvrirMenu dont l'emplacement (position) n'est pas automatique
    //ment calculée
    ui->btnOuvrirMenu->move(ui->btnQuitter->pos());
    ui->btnOuvrirMenu->resize(QPixmap(QString(":/abuledugraphicmenuv1/btnOuvrirMenu")).size()*ratio);
}

void AbulEduGraphicMenuV1::on_btnQuitter_clicked()
{
    emit btnQuitterTriggered();
    if(m_localDebug) qDebug()<<"btnQuitterTriggered emis";
}

void AbulEduGraphicMenuV1::on_btnBox_clicked()
{
    emit btnBoxTriggered();
    if(m_localDebug) qDebug()<<"btnBoxTriggered emis";
}

void AbulEduGraphicMenuV1::on_btnFermer_clicked()
{
    //pseudo animation pour la fermeture du menu
    ui->btnFermer->hide();
    plierMenu();
}

void AbulEduGraphicMenuV1::on_btnAide_clicked()
{
    emit btnAideTriggered();
    if(m_localDebug) qDebug()<<"btnAideTriggered emis";
}


void AbulEduGraphicMenuV1::on_btnLivret_clicked()
{
    emit btnLivretTriggered();
    if(m_localDebug) qDebug()<<"btnLivretTriggered emis";
}

/**
  * @note utilisation de la liste pour qu'on puisse specifier un ordre
  * d'icones différent dans le fichier conf ... par contre la numérotation est inversée
  * @see https://redmine.ryxeo.com/projects/ryxeo/wiki/Le_menu_graphique
  */
void AbulEduGraphicMenuV1::plierDeplierMenu(bool deplier)
{
    if(m_localDebug)
        qDebug() << "AbulEduGraphicMenuV1::plierDeplierMenu" << m_animationStep;

    switch(m_animationStep) {
    case 11:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        afficherCacher(m_listeComposants.at(1),deplier);
        break;
    case 10:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        afficherCacher(m_listeComposants.at(2),deplier);
        break;
    case 9:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        afficherCacher(m_listeComposants.at(3),deplier);
        break;
    case 8:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        afficherCacher(m_listeComposants.at(4),deplier);
        break;
    case 7:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        if(m_listeComposants.size()>5)
            afficherCacher(m_listeComposants.at(5),deplier);
        break;
    case 6:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        if(m_listeComposants.size()>6)
            afficherCacher(m_listeComposants.at(6),deplier);
        break;
    case 5:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-04");
        if(m_listeComposants.size()>7)
            afficherCacher(m_listeComposants.at(7),deplier);
        break;
    case 4:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-03");
        break;
    case 3:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-02");
        break;
    case 2:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-01");
        break;
    case 1:
        m_imageFond.load(":/abuledugraphicmenuv1/fond-01");
        ui->btnOuvrirMenu->hide();
        break;
    case 0:
        ui->btnOuvrirMenu->show();
        m_imageFond.load(":/abuledugraphicmenuv1/fond-00");
        emit btnFermerTriggered();
        break;
    default:
        break;
    }
    //Si on n'a pas terminé de plier le menu on tourne un tour de plus
    if(!deplier && m_animationStep > 0) {
        QTimer::singleShot(150,this,SLOT(plierMenu()));
        m_animationStep--;
    }
    //Si on n'a pas terminé de déplier le menu on tourne un tour de plus
    if(deplier && m_animationStep < 11) {
        QTimer::singleShot(150,this,SLOT(deplierMenu()));
        m_animationStep++;
    }
    //si on doit bouger encore
    if(m_animationStep > 0 || m_animationStep < 11) {
        setDimensionsWidget();
    }
}

void AbulEduGraphicMenuV1::plierMenu()
{
    plierDeplierMenu(false);
}

void AbulEduGraphicMenuV1::deplierMenu()
{
    plierDeplierMenu(true);
}

/**
  * Permet d'afficher ou de cacher un objet en utilisant son nom
  */
void AbulEduGraphicMenuV1::afficherCacher(QString composant, bool deplier)
{
    if(QPointer<AbulEduFlatBoutonV1> btn = findChild<AbulEduFlatBoutonV1 *>(composant)) {
        btn.data()->setVisible(deplier);
    }
    else if (QPointer<QLabel> l = findChild<QLabel *>(composant)) {
        l.data()->setVisible(deplier);
    }
}

void AbulEduGraphicMenuV1::on_btnParametres_clicked()
{
    emit btnParametresTriggered();
}

void AbulEduGraphicMenuV1::on_btnOuvrir_clicked()
{
    emit btnOuvrirTriggered();
}

void AbulEduGraphicMenuV1::on_btnOuvrirMenu_clicked()
{
    plierDeplierMenu(true);
}
