/** Classe AbulEduIdentitesAvatarsListingV1 : affiche tous les avatars disponibles
  *
  * @author 2012 Eric Seigne <eric.seigne@ryxeo.com>
  * @see The GNU Public License (GNU/GPL) v3
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program; if not, write to the Free Software Foundation, Inc.,
  * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  */

#include "abuleduidentitesavatarslistingv1.h"
#include "ui_abuleduidentitesavatarslistingv1.h"

AbulEduIdentitesAvatarsListingV1::AbulEduIdentitesAvatarsListingV1(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::AbulEduIdentitesAvatarsListingV1)
{
    ui->setupUi(this);

    QDir dir(":/abuleduidentitesv1/avatars/");
    dir.setFilter(QDir::Files);
    QFileInfoList list = dir.entryInfoList();
    int ligne = 0;
    int col = 0;
    for (int i = 0; i < list.size(); ++i) {
        AbulEduFlatBoutonV1 *btn = new AbulEduFlatBoutonV1(this);
        ui->gridLayout->addWidget(btn,ligne,col,1,1,0);
        btn->setMinimumSize(64,64);
        btn->setMaximumSize(64,64);
        btn->setIconeNormale(list.at(i).absoluteFilePath());
        btn->setCursor(Qt::PointingHandCursor);
        btn->show();
        btn->setObjectName(list.at(i).absoluteFilePath());
        connect(btn,SIGNAL(clicked()),this,SLOT(slotChoixAvatar()),Qt::UniqueConnection);

        //10 icones par ligne
        col++;
        if(col == 10) {
            col = 0;
            ligne++;
        }
    }
}

AbulEduIdentitesAvatarsListingV1::~AbulEduIdentitesAvatarsListingV1()
{
    delete ui;
}

void AbulEduIdentitesAvatarsListingV1::slotChoixAvatar()
{
    qDebug() << "Choix de l'avatar suivant : " << sender()->objectName();
    emit signalChoixAvatar(sender()->objectName());
    close();
}
