/**
  * Classe
  * @see https://redmine.ryxeo.com/projects/
  * @author 2012 Eric Seigne <eric.seigne@ryxeo.com>
  * @see The GNU Public License (GNU/GPL) v3
  *
  *
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program. If not, see <http://www.gnu.org/licenses/>.
  */


#ifndef ABULEDUVIRTUALKEYBOARDGUIV1_H
#define ABULEDUVIRTUALKEYBOARDGUIV1_H

#include <QWidget>
#include <QDebug>
#include <QLineEdit>
#include <QPointer>
#include <QDesktopWidget>
#include <QKeyEvent>
#include <QSound>
#include <QFontDatabase>

namespace Ui {
class AbulEduVirtualKeyboardGuiV1;
}

class AbulEduVirtualKeyboardGuiV1 : public QWidget
{
    Q_OBJECT

public:
    explicit AbulEduVirtualKeyboardGuiV1(QWidget *parent = 0);
    ~AbulEduVirtualKeyboardGuiV1();
    void abeSetInputWidget(QWidget *w);
    QWidget *abeGetInputWidget();

private slots:
    void changeClavier();
    void clavierNormalMIN();
    void clavierNormalMAJ();
    void clavierAccentsMIN();
    void clavierAccentsMAJ();
    void clavierNUM();
    void slotBtnLettreClicked();
    void on_btnSHIFTLeft_toggled(bool checked);
    void on_btnBACK_clicked();
    void on_btnClose_clicked();
    void on_btnACCENTS_toggled(bool checked);

    void on_btnCHANGE_toggled(bool checked);

    void on_btnLettreRETURN_clicked();
    void testControlePosition();

    void on_btnDroite_clicked();

    void on_btnGauche_clicked();

private:
    Ui::AbulEduVirtualKeyboardGuiV1 *ui;
//    QPointer<QLineEdit> m_le;
    QWidget   *m_inputWidget;

    void showEvent(QShowEvent * event);
    bool m_hasMoved;
    bool m_localDebug;
    QRect m_positionOrigine;
    QRect m_positionOrigineViewport;
    bool m_viewportHasMoved;

    QWidget *m_parent;
    void controlePosCursor(QWidget *widget_aControler);
};

#endif // ABULEDUVIRTUALKEYBOARDGUIV1_H
