/**
  * Classe
  * @see https://redmine.ryxeo.com/projects/
  * @author 2012 Eric Seigne <eric.seigne@ryxeo.com>
  * @see The GNU Public License (GNU/GPL) v3
  *
  *
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program. If not, see <http://www.gnu.org/licenses/>.
  */


#ifndef ABULEDUVIRTUALKEYBOARDV1_H
#define ABULEDUVIRTUALKEYBOARDV1_H

#include <QSignalMapper>
#include <QInputContext>
#include "abuleduvirtualkeyboardv1.h"
#include "abuleduvirtualkeyboardguiv1.h"

class AbulEduVirtualKeyboardV1 : public QInputContext
{
    Q_OBJECT

public:
    explicit AbulEduVirtualKeyboardV1();
    ~AbulEduVirtualKeyboardV1();
    void abeSetEnabled(bool enabled);
    QString identifierName();
    QString language();
    bool isComposing() const;
    void reset();
    bool filterEvent(const QEvent* event);

signals:
    void characterGenerated(QChar character);

private slots:
    void saveFocusWidget(QWidget* a,QWidget* b);

private:
    AbulEduVirtualKeyboardGuiV1 *m_abuleduVirtualKeyboardGuiV1;
    bool m_localDebug;
    bool m_isEnabled;
};

#endif // ABULEDUVIRTUALKEYBOARDV1_H
