/**
  * (le terrier d'AbulEdu)
  *
  * @warning aucun traitement d'erreur n'est pour l'instant implémenté
  * @see https://redmine.ryxeo.com/projects/leterrier-aller
  * @author 2011 Jean-Louis Frucot <frucot.jeanlouis@free.fr>
  * @see The GNU Public License (GPL)
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  * for more details.
  *
  * You should have received a copy of the GNU General Public License along
  * with this program; if not, write to the Free Software Foundation, Inc.,
  * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  */

#include "abuleduwidgetassistantetapesv1.h"
#include "ui_abuleduwidgetassistantetapesv1.h"

AbulEduWidgetAssistantEtapesV1::AbulEduWidgetAssistantEtapesV1(QList<QPair<QString, QString> > listeEtapes,
                                                               int smallFontSize,
                                                               int mediumFontSize,
                                                               int largeFontSize,
                                                               QWidget *parent)  :
    QWidget(parent),
    ui(new Ui::AbulEduWidgetAssistantEtapesV1),
    m_etapeCourante(0)
{
    m_localDebug = DEBUG_ASSISTANTETAPESV1;

    if (m_localDebug) qDebug() << __FILE__ <<  __LINE__ << __FUNCTION__<<"-----------Constructeur";

    ui->setupUi(this);
    ui->pbSuivant->setIconeNormale(":/widgetAssistantEtapes/flecheDroite");
    ui->pbSuivant->setIconeSurvol(":/widgetAssistantEtapes/flecheDroiteOver");
    ui->pbSuivant->setIconeDisabled(":/widgetAssistantEtapes/flecheDroiteGris");

    ui->pbRetour->setIconeNormale(":/widgetAssistantEtapes/flecheGauche");
    ui->pbRetour->setIconeSurvol(":/widgetAssistantEtapes/flecheGaucheOver");
    ui->pbRetour->setIconeDisabled(":/widgetAssistantEtapes/flecheGaucheGris");

    ui->pbQuitter->setIconeNormale(":/widgetAssistantEtapes/quitter");
    ui->pbQuitter->setIconeSurvol(":/widgetAssistantEtapes/quitterOver");
    m_signalMapper = new QSignalMapper(this);
    m_MapBoutonsEtapes.clear();
    m_buttonsActivated = true; // Boutons cliquables par défaut

    abeWidgetAssistantCreateEtapes(listeEtapes);
    abeWidgetAssistantSetEtapeCourante(0); // Page d'accueil
    abeWidgetAssistantSetFontSize(smallFontSize, mediumFontSize, largeFontSize);
    ui->pbSuivant->setEnabled(false);
}

AbulEduWidgetAssistantEtapesV1::~AbulEduWidgetAssistantEtapesV1()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;
    delete ui;
}

void AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantSetEtapeCourante(int etapeCourante)
{
    if (m_localDebug) qDebug() <<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__<<"  etapeCourante demandee "<<etapeCourante<<"  nb Etapes"<<m_nbEtapes;

    m_etapeCourante = etapeCourante;

    // On va fixer la taille de la police du bouton en fonction de sa "distance" avec l'étape courante
    for(int i=0; i<m_nbEtapes; i++)
    {
        if (m_localDebug) qDebug()<<"m_etapeCourante - m_nbEtapes + 2 +i"<<m_etapeCourante - m_nbEtapes + 2 +i<<"i-m_etapeCourante"<<i-m_etapeCourante;
        switch(i - m_etapeCourante)
        {
        case -1:
        {
            m_MapBoutonsEtapes.value(i).first->setFont(m_mediumFont);
            m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.first + " ->");
            break;
        }
        case 0:
        {
            m_MapBoutonsEtapes.value(i).first->setFont(m_largeFont);
            if(i != m_nbEtapes -1)
            {
                m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.first + " ->");
            }
            else
            {
                m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.first);
            }
            break;
        }
        case 1:
        {
            m_MapBoutonsEtapes.value(i).first->setFont(m_mediumFont);
            if(i != m_nbEtapes -1)
            {
                m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.first + " ->");
            }
            else
            {
                m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.first);
            }
            break;
        }
        default:
        {
            m_MapBoutonsEtapes.value(i).first->setFont(m_smallFont);
            if(i != m_nbEtapes -1)
            {
                m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.second + " ->");
            }
            else
            {
                m_MapBoutonsEtapes.value(i).first->setText(m_MapBoutonsEtapes.value(i).second.second);
            }
            break;
        }
        }

    }
    emit signalEtapeHasChanged(m_etapeCourante);

    if(m_etapeCourante == 0)
    {
        ui->pbRetour->setEnabled(false);
        ui->pbSuivant->setEnabled(false); // Il faut cliquer sur l'un des boutons de choix de fichier à créer/modifier
    }
    else if(m_etapeCourante == m_nbEtapes - 1)
    {
        ui->pbSuivant->setEnabled(false);
    }
    else
    {
        ui->pbRetour->setEnabled(true);
        ui->pbSuivant->setEnabled(true);
    }
}

void AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantSetFontSize(int smallFontSize, int mediumFontSize, int largeFontSize)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;
    m_smallFont = font();
    m_smallFont.setPixelSize(smallFontSize);
    m_mediumFont = font();
    m_mediumFont.setPixelSize(mediumFontSize);
    m_largeFont = font();
    m_largeFont.setPixelSize(largeFontSize);
    m_largeFont.setBold(true);

    abeWidgetAssistantSetEtapeCourante(m_etapeCourante); // Met à jour les boutons
}

void AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantCreateEtapes(QList<QPair<QString, QString> > listeEtapes)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    // On va détruire les boutons qui auraient pu être créés auparavant
    if(!m_MapBoutonsEtapes.isEmpty())
    {
        for(int i=0; i<m_MapBoutonsEtapes.count(); i++)
        {
            m_MapBoutonsEtapes.value(i).first->deleteLater();
        }
        m_MapBoutonsEtapes.clear();
    }

    int index = 2; // index vaut 2 car il y a le bouton quitter et un spacer en index 0 et 1 dans ui->hLayoutBoutons
    QPair<QString, QString> etape;
    foreach(etape, listeEtapes)
    {
        AbulEduFlatBoutonV1 *bouton = new AbulEduFlatBoutonV1();
        bouton->setText(etape.first + " >");
        connect(bouton, SIGNAL(clicked()), m_signalMapper, SLOT(map()));
        m_signalMapper->setMapping(bouton,index-2);
        ui->hLayoutBoutons->insertWidget(index, bouton);
        QPair<AbulEduFlatBoutonV1 *, QPair< QString, QString> > item(bouton, etape);
        m_MapBoutonsEtapes.insert(index - 2, item);
        index++;
    }
    connect(m_signalMapper, SIGNAL(mapped(int)), this, SLOT(boutonEtapeClicked(int)));
    m_nbEtapes = index - 2;
}

void AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantEnableSuivant(bool enabled)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    ui->pbSuivant->setEnabled(enabled);
}

void AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantEnablePrecedent(bool enabled)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    ui->pbRetour->setEnabled(enabled);
}

void AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantEnableClick(bool yesNo)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__<<"Boutons activés ?"<<yesNo;

    m_buttonsActivated = yesNo;
}

QList<AbulEduFlatBoutonV1 *> AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantGetButtons()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    QList<AbulEduFlatBoutonV1 *> boutons;
    for(int i =0; i<m_nbEtapes; i++)
    {
        boutons.append(m_MapBoutonsEtapes.value(i).first);
    }
    return boutons;
}

AbulEduFlatBoutonV1 *AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantGetButton(int i)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    if(i >= 0 && i < m_nbEtapes)
    {
        return m_MapBoutonsEtapes.value(i).first;
    }
    else
    {
        return 0;
    }
}

AbulEduFlatBoutonV1 *AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantGetButtonNext()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    return ui->pbSuivant;
}

AbulEduFlatBoutonV1 *AbulEduWidgetAssistantEtapesV1::abeWidgetAssistantGetButtonPrevious()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    return ui->pbRetour;
}

void AbulEduWidgetAssistantEtapesV1::on_pbRetour_clicked()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    emit signalEtapePrecedenteRequested();
    if(m_etapeCourante >= 0)
    {
        m_etapeCourante--;
        abeWidgetAssistantEnableClick(true);
        abeWidgetAssistantSetEtapeCourante(m_etapeCourante);
        emit signalEtapeHasChanged(m_etapeCourante);
    }

}

void AbulEduWidgetAssistantEtapesV1::on_pbSuivant_clicked()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    emit signalEtapeSuivanteRequested();
    if(m_etapeCourante < m_nbEtapes-1)
    {
        m_etapeCourante++;
        abeWidgetAssistantEnableClick(true);
        abeWidgetAssistantSetEtapeCourante(m_etapeCourante);
        emit signalEtapeHasChanged(m_etapeCourante);
    }
}

void AbulEduWidgetAssistantEtapesV1::on_pbQuitter_clicked()
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;

    emit signalQuitterRequested();
}


void AbulEduWidgetAssistantEtapesV1::boutonEtapeClicked(int numBouton)
{
    if (m_localDebug) qDebug()<<" ++++++++++++ "<< __FILE__ <<  __LINE__ << __FUNCTION__;
    if(m_buttonsActivated)
    {
        if(m_localDebug)qDebug()<<"                     Bouton No"<<numBouton;
        if(m_etapeCourante!=numBouton)
        {
            abeWidgetAssistantSetEtapeCourante(numBouton);
        }
    }

}
